;##################################################################
; CHMViewer
; Just a little feasibility test for a CHM viewer
;##################################################################

STRINGS UNICODE

#include CHMViewer.h

CONSTANT SECTION
	IID_IITStorage GUID GUID_IID_IITStorage
	CLSID_MSITStore GUID GUID_CLSID_ITStorage
	IID_IWebBrowser2 GUID GUID_IID_IWebBrowser2

DATA SECTION
	hInstance	HANDLE		?
	pMITSStore	PTR			?
	mkFormat DUS "mk:@MSITStore:%s::/%s",0
	FilePath DUS "win32asm tutorial.chm",0
	pstgOpen PTR ?

	hAtl		HANDLE ?
	hList		HANDLE ?
	pWebIUnknown PTR ?
	pIWebBrowser2 PTR ?
	pSTATSTG		PTR ?

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControls
	invoke CoInitialize,NULL
	invoke AtlAxWinInit
	invoke OpenCHM,offset FilePath,offset pMITSStore,offset pstgOpen
	test eax,eax
	js >>

;	invoke EnumerateCHMStreams,[pstgOpen],ENUM_STGTY_ALL,offset EnumerationCallback, 0

	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0

	CoInvoke(pstgOpen,IStorage.IUnknown.Release)
	CoInvoke(pMITSStore,IITStorage.IUnknown.Release)
	:

	invoke CoUninitialize

	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,esi,ebx
	LOCAL rect:RECT
	LOCAL pFile:%PTR
	LOCAL cbWritten:D
	LOCAL UrlName[1024]:B

	.WM_INITDIALOG
		cmp D[uMsg],WM_INITDIALOG
		jne >>.WM_COMMAND
		invoke GetClientRect,[hwnd],offset rect
		// Create the WebBrowser window
		invoke CreateWindowEx,NULL,L"AtlAxWin",L"about:blank",WS_CHILD + WS_VISIBLE + WS_VSCROLL, \
			0,0,[rect.right],250,[hwnd],1002,[hInstance],NULL
		mov [hAtl],eax

		mov eax,[rect.bottom]
		sub eax,260

		invoke CreateWindowEx,0x200,L"Listbox",L"",0x50010141+WS_VSCROLL, \
			0,260,[rect.right],eax,[hwnd],1001,[hInstance],NULL

		mov [hList],eax

		invoke AtlAxGetControl, [hAtl],offset pWebIUnknown
		CoInvoke(pWebIUnknown,IWebBrowser2.IUnknown.QueryInterface,offset IID_IWebBrowser2,offset pIWebBrowser2)

		invoke ReadTopics,[pstgOpen],[hList]

		jmp >>.EXIT

	.WM_COMMAND
		cmp D[uMsg],WM_COMMAND
		jne >>.WM_CLOSE
		mov eax,[wParam]
		mov edx,eax
		and eax,0xFFFF
		shr edx,16
		cmp eax,1001
		jne >>.EXIT
		cmp edx,LBN_DBLCLK
		jne >>.EXIT
			invoke SendMessage,[hList],LB_GETCURSEL,0,0
			invoke SendMessage,[hList],LB_GETITEMDATA,eax,0
			mov ebx,eax
			// Format the urlName
			invoke wsprintf,offset UrlName,offset mkFormat,offset FilePath,ebx
			add esp,16

			invoke GoToURL,[pIWebBrowser2],offset UrlName
		jmp >>.EXIT

	.WM_CLOSE
		cmp D[uMsg],WM_CLOSE
		jne >.DEFPROC
		// Free the url buffers
		invoke SendMessage,[hList],LB_GETCOUNT,0,0
		mov ebx,eax
		:
			dec ebx
			invoke SendMessage,[hList],LB_GETITEMDATA,ebx,0
			invoke GlobalFree,eax
			test ebx,ebx
			jns <

		CoInvoke(pIWebBrowser2,IWebBrowser2.IUnknown.Release)
		CoInvoke(pWebIUnknown,IWebBrowser2.IUnknown.Release)

		invoke EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	RET
ENDF

GoToURL FRAME pInterface, pszURL
	LOCAL pbszURL:%PTR
	LOCAL flags:VARIANT

	mov W[flags.vt], VT_I2
	mov W[flags.iVal], 0

	invoke SysAllocString,[pszURL]
	mov [pbszURL],eax

	//_self = use the same webbrowser window
	CoInvoke(pInterface,IWebBrowser2.Navigate,[pbszURL],offset flags,"_self",NULL,NULL)
	push eax
	invoke SysFreeString,[pbszURL]
	pop eax
	RET
ENDF

ReadTopics FRAME pStgStream, hListbox
	uses edi,esi,ebx
	LOCAL pTopics:%PTR
	LOCAL eoTopics:D
	LOCAL pStrings:%PTR
	LOCAL pUrlTbl:%PTR
	LOCAL pUrlStr:%PTR
	LOCAL hData:%PTR
	LOCAL cbRead:D
	LOCAL ObjBuffer[256]:W

	// Allocate our buffers
	invoke GlobalAlloc,GMEM_FIXED,65536*16
	mov [pTopics],eax
	invoke GlobalAlloc,GMEM_FIXED,65536*16
	mov [pStrings],eax
	invoke GlobalAlloc,GMEM_FIXED,65536*16
	mov [pUrlTbl],eax
	invoke GlobalAlloc,GMEM_FIXED,65536*16
	mov [pUrlStr],eax

	mov D[cbRead],65536*16
	invoke ReadStream,[pStgStream],[pTopics],L"#TOPICS",offset cbRead
	mov eax,[pTopics]
	add eax,[cbRead]
	mov [eoTopics],eax

	mov D[cbRead],65536*16
	invoke ReadStream,[pStgStream],[pStrings],L"#STRINGS",offset cbRead
	
	mov D[cbRead],65536*16
	invoke ReadStream,[pStgStream],[pUrlTbl],L"#URLTBL",offset cbRead
	
	mov D[cbRead],65536*16
	invoke ReadStream,[pStgStream],[pUrlStr],L"#URLSTR",offset cbRead

	// Walk the topics
	mov edi,[pTopics]
	:

	mov esi,[pStrings]
	add esi,[edi+TOPICS.pName]
	invoke MultiByteToWideChar,CP_ACP,NULL,esi,-1,offset ObjBuffer,256
	invoke SendMessage,[hListbox],LB_ADDSTRING,0,offset ObjBuffer
	push eax

	mov esi,[pUrlTbl]
	add esi,[edi+TOPICS.pURLTBL]

	// Allocate a buffer for the itemdata
	invoke GlobalAlloc,GMEM_FIXED,256
	mov [hData],eax
	mov ebx,[pUrlStr]
	add ebx,[esi+URLTBL.pUrlString]
	add ebx,URLSTR.szFilename
	invoke MultiByteToWideChar,CP_ACP,NULL,ebx,-1,[hData],256
	pop eax
	invoke SendMessage,[hListbox],LB_SETITEMDATA,eax,[hData]
	;PrintString(ObjBuffer)

	add edi,SIZEOF TOPICS
	cmp edi,[eoTopics]
	jl <<

	invoke GlobalFree,[pTopics]
	invoke GlobalFree,[pStrings]
	invoke GlobalFree,[pUrlTbl]
	invoke GlobalFree,[pUrlStr]

	ret
endf

ReadStream FRAME pStorage, pMemory, pwszStreamName, pcbCopied
	LOCAL pStream:D

	// Reads a stream into the memory buffer supplied
	// the size of the buffer must be in the location pointed
	// to by pcbCopied. Returns the number of bytes read in the
	// location pointed to by pcbCopied

	CoInvoke(pStorage,IStorage.OpenStream,[pwszStreamName],0,STGM_SHARE_EXCLUSIVE,0,offset pStream)
	test eax,eax
	jnz >>.NOINTERFACE
	cmp D[pStream],0
	je >>.NOINTERFACE
	mov eax,[pcbCopied]
	mov eax,[eax]
	test eax,eax
	jz >>.NOINTERFACE

	push eax
	CoInvoke(pStream,IStream.Read,[pMemory],eax,[pcbCopied])
	pop eax
	mov ecx,[pcbCopied]
	mov ecx,[ecx]

	cmp ecx,eax
	jge >.BUFFERTOOSMALL

	CoInvoke(pStream,IStream.IUnknown.Release)
	invoke SetLastError,0
	xor eax,eax
	RET

	.BUFFERTOOSMALL
	CoInvoke(pStream,IStream.IUnknown.Release)
	invoke SetLastError,ERROR_MORE_DATA
	xor eax,eax
	RET

	.NOINTERFACE
	invoke SetLastError,ERROR_FILE_NOT_FOUND
	mov eax,-1
	RET
ENDF

OpenCHM FRAME pwszChmFile, ppITSStore, ppStorage
	// Opens a CHM file and returns a pointer to an IITStorage and IStorage interface
	mov eax,[ppStorage]
	mov edx,[eax]
	test edx,edx
	jz >
		push eax
		CoInvoke(edx,IStorage.IUnknown.Release)
		pop eax
		mov D[eax],0
	:
	mov eax,[ppITSStore]
	mov edx,[eax]
	test edx,edx
	jz >
		push eax
		CoInvoke(edx,IITStorage.IUnknown.Release)
		pop eax
		mov D[eax],0
	:

	invoke CoCreateInstance,offset CLSID_MSITStore, NULL, CLSCTX_ALL,offset IID_IITStorage, [ppITSStore]
	test eax,eax
	jnz >>.NOINTERFACE
	CoInvoke(pMITSStore,IITStorage.StgOpenStorage,[pwszChmFile],0,STGM_READ,0,0,[ppStorage])
	test eax,eax
	jnz >>.NOSTGINTERFACE
	
	RET
	.NOSTGINTERFACE
		mov eax,[ppITSStore]
		mov edx,[eax]
		CoInvoke(edx,IStorage.IUnknown.Release)
	.NOINTERFACE
		mov eax,-1
	ret
ENDF

EnumerateCHMStreams FRAME pStorage, Type, pCallback, lParam
	LOCAL cCount:D
	LOCAL pIEnum :D
	LOCAL cFetched:D

	// Function : EnumerateCHMStreams
	// Parameters :
	// pStorage = pointer to an IITStorage interface
	// Type = the type of item that should be enumerated
	// pCallback = pointer to an callback function
	// lParam = application defined value passed to the callback

	// Enumerates the streams in the file and passes a pointer to 
	// an STATSTG structure to an application defined callback
	// The enumeration handles freeing the memory allocated by the
	// enumeration object
	// The callback routine should return TRUE to continue the enumeration
	// or FALSE to stop it

	// Reset the counter
	mov D[cCount],1

	// Check for invalid pointers
	cmp D[pStorage],0
	je >>.NOINTERFACE
	cmp D[pCallback],0
	je >>.NOINTERFACE

	// Get an enumeration interface pointer
	CoInvoke(pStorage,IStorage.EnumElements,0,0,0,offset pIEnum)
	cmp D[pIEnum],0
	je >>.NOINTERFACE
	test eax,eax
	jnz >>.NOINTERFACE
	// Walk through the enumeration
	:
		CoInvoke(pIEnum,IEnumSTATSTG.Next,1,offset pSTATSTG,offset cFetched)
		cmp D[cFetched],0
		jz >>.ENDENUM
		// Check to see if the type matches
		mov eax,offset pSTATSTG
		mov eax,[eax+STATSTG.type]
		cmp D[Type],0
		je >>.CALLENUM
		and eax,[Type]
		test eax,eax
		jz >>.NOCALLBACK

		.CALLENUM
		// pass the data to the callback
		invoke [pCallback],[cCount],offset pSTATSTG, [lParam]
		// push the return result from the callback
		push eax
		// Free the task memory allocated by the enumeration
		mov eax, offset pSTATSTG
		mov eax,[eax]
		invoke CoTaskMemFree,eax
		pop eax
		test eax,eax
		jz >>.ENDENUM
		.NOCALLBACK
		inc D[cCount]
		jmp <<

	.ENDENUM

	CoInvoke(pIEnum,IEnumSTATSTG.Reset)
	CoInvoke(pIEnum,IEnumSTATSTG.IUnknown.Release)
	xor eax,eax
	RET

	.NOINTERFACE
	mov eax,-1
	RET
ENDF

EnumerationCallback FRAME count, pSTATSTG, lParam
	uses edi,ebx

	// This is the callback, this one does nothing at all
	mov eax,TRUE
	RET
ENDF